<!--
  -    Copyright [2020-2021] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row>
    <v-snackbar
      v-model="snackbar.show"
      :color="error.length !== 0 ? 'error' : 'success'"
      top
      multi-line
      vertical
    >
      <div v-if="error.length !== 0">
        Es sind Fehler aufgetreten, die behoben werden müssen:

        <ul>
          <li v-for="e in error" :key="e">
            {{ e }}
          </li>
        </ul>
      </div>
      <div v-else>
        {{ snackbar.message }}
      </div>
    </v-snackbar>
    <v-col :cols="applicationStore.session.miniSession ? 12 : 6">
      <v-card>
        <v-card-title>Benutzerinformation</v-card-title>
        <v-card-text>
          <v-row>
            <v-col>
              <v-text-field
                label="Vorname"
                prepend-icon="mdi-account-box"
                v-model="applicationStore.session.user.firstname"
                disabled
              />
            </v-col>
            <v-col>
              <v-text-field
                label="Nachname"
                prepend-icon="mdi-account-box-outline"
                v-model="applicationStore.session.user.surname"
                disabled
              />
            </v-col>
          </v-row>

          <v-text-field
            label="Anzeigename"
            prepend-icon="mdi-card-account-details"
            v-model="applicationStore.session.user.username"
            disabled
          />

          <v-text-field
            label="E-Mail"
            prepend-icon="mdi-email"
            v-model="applicationStore.session.user.mail"
            disabled
          />
        </v-card-text>

        <v-card-actions>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doChangeUsername"
            :loading="loading"
            disabled
            >Speichern
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
    <v-col cols="6" v-if="!applicationStore.session.miniSession">
      <v-card>
        <v-card-title>Profilbild</v-card-title>
        <v-card-text>
          <img
            :src="util.CONFIG.API_BASE_URL + `/v1/users/${applicationStore.session.user.id}/image`"
            @error="
              () => {
                hasProfileImage = false;
              }
            "
            v-show="hasProfileImage"
            ref="profileImage"
          />
        </v-card-text>
        <v-card-actions>
          <v-spacer />
          <v-btn
            v-if="hasProfileImage"
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            :loading="loading"
            type="button"
            @click="doResetImage()"
            :disabled="loading"
            >Zurücksetzen
          </v-btn>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            :loading="loading"
            type="button"
            @click="imageOverlay.show = true"
            :disabled="loading"
            >{{ hasProfileImage ? 'Ändern' : 'Hochladen' }}
          </v-btn>
        </v-card-actions>
      </v-card>
      <v-overlay :value="imageOverlay.show">
        <v-card>
          <v-card-title>Profilbild ändern</v-card-title>
          <v-card-text>
            <input type="file" accept="image/*" @change="onSetImage" />
            <canvas id="processing" height="100px" width="100px"></canvas>
          </v-card-text>
          <v-card-actions>
            <v-btn @click="imageOverlay.show = false" :disabled="imageOverlay.loading"
              >Abbrechen</v-btn
            >
            <v-spacer />
            <v-btn
              :disabled="imageOverlay.loading || imageOverlay.image === null"
              :loading="imageOverlay.loading"
              @click="doSetImage"
            >
              Hinzufügen
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-overlay>
    </v-col>
    <v-col cols="6" v-if="!applicationStore.session.miniSession">
      <v-form ref="formPassword" v-on:submit.prevent="doChangePassword">
        <v-card>
          <v-card-title>Passwort ändern</v-card-title>
          <v-card-text>
            <v-row>
              <v-col>
                <v-text-field
                  label="Altes Passwort"
                  name="password0"
                  type="password"
                  prepend-icon="mdi-lock-open"
                  v-model="changePassword.passwordOld"
                  :disabled="loading"
                  :rules="passwordRules"
                />
              </v-col>
            </v-row>

            <v-text-field
              label="Neues Passwort"
              name="password1"
              type="password"
              prepend-icon="mdi-lock"
              v-model="changePassword.password1"
              :disabled="loading"
              :rules="passwordRules"
            />

            <v-text-field
              label="Passwort wiederholen"
              name="password2"
              prepend-icon="mdi-lock"
              type="password"
              v-model="changePassword.password2"
              :error-messages="passwordConfirmationRule()"
              :disabled="loading"
            />
          </v-card-text>
          <v-card-actions>
            <v-spacer />
            <v-btn
              color="orange darken-2"
              class="pa-4 white--text"
              tile
              :loading="loading"
              type="submit"
              :disabled="loading"
              >Speichern
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-form>
    </v-col>
    <v-col cols="6" v-if="!applicationStore.session.miniSession">
      <v-form ref="formMailAddress" v-on:submit.prevent="doChangeMailAddress">
        <v-card>
          <v-card-title>Mail-Adresse ändern</v-card-title>
          <v-card-text>
            <v-text-field
              label="Aktuelles Passwort"
              name="password_for_mail_change"
              type="password"
              prepend-icon="mdi-lock-open"
              v-model="changeMailAddress.password"
              :disabled="loading"
            />
            <v-text-field
              label="Neue Mail-Adresse"
              name="mail"
              prepend-icon="mdi-email-open"
              v-model="changeMailAddress.mail"
              :disabled="loading"
              :rules="[util.validateMail]"
            />
            <v-checkbox
              v-model="changeMailAddress.verified"
              :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
              :disabled="loading"
              required
            >
              <template v-slot:label>
                Ich bin Besitzer dieser E-Mail-Adresse und werde dies durch Klicken des zugesandten
                Verifizierungs-Link innerhalb von 30 Minuten bestätigen.
              </template>
            </v-checkbox>
          </v-card-text>
          <v-card-actions>
            <v-spacer />
            <v-btn
              color="orange darken-2"
              class="pa-4 white--text"
              tile
              :loading="loading"
              type="submit"
              :disabled="loading"
              >Speichern
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-form>
    </v-col>
  </v-row>
</template>

<script>
import Util from '../LegacyUtil';
import * as util from "../util";
import { useApplicationStore } from '../stores/application';

export default {
  methods: {
    passwordConfirmationRule: function () {
      return this.changePassword.password1 === this.changePassword.password2
        ? ''
        : 'Passwörter müssen übereinstimmen';
    },
    doChangeUsername: function () {
      // TODO: not implemented yet. Form is disabled.
    },
    //Adapted from https://hacks.mozilla.org/2011/01/how-to-develop-a-html5-image-uploader/
    onSetImage: async function (event) {
      const input = event.target;
      var file = input.files[0];

      // Load file as image outside DOM, so we can get its dimensions
      let img = document.createElement('img');
      img.src = window.URL.createObjectURL(file);
      await new Promise((resolve) => (img.onload = resolve)); //wait for image load

      /* Resize image */
      var width = img.width;
      var height = img.height;
      var overflow_width = 0;
      var overflow_height = 0;
      var scale;

      const SQUARE_SIDE = 100;

      if (width > height) {
        scale = SQUARE_SIDE / height;
        overflow_width = width - height;
      } else {
        scale = SQUARE_SIDE / width;
        overflow_height = height - width;
      }

      const canvas = document.getElementById('processing');
      var ctx = canvas.getContext('2d');
      ctx.drawImage(
        img,
        (-overflow_width / 2) * scale,
        (-overflow_height / 2) * scale,
        width * scale,
        height * scale
      );
      this.imageOverlay.image = await new Promise((resolve) =>
        canvas.toBlob(resolve, 'image/jpeg')
      );

      // Now the img goes out of scope, and we don't need the associated URL
      window.URL.revokeObjectURL(img.src);
    },
    doResetImage: async function () {
      this.error = [];
      this.snackbar.show = false;
      this.loading = true;

      try {
        const response = await fetch(util.CONFIG.API_BASE_URL + '/v1/account/image', {
          method: 'DELETE',
          credentials: 'include',
        });
        if (!response.ok) throw Error(`Status code ${response.status} when trying to delete image`);
        this.hasProfileImage = false;
      } catch (error) {
        console.log(error);
        this.$emit('networkError');
      }
      this.loading = false;
    },

    doSetImage: async function () {
      this.error = [];
      this.snackbar.show = false;
      this.loading = true;

      const formData = new FormData();
      formData.append('profileImage', this.imageOverlay.image);

      this.imageOverlay.show = false;

      try {
        const response = await fetch(util.CONFIG.API_BASE_URL + '/v1/account/setimage', {
          method: 'POST',
          credentials: 'include',
          body: formData,
        });

        if (response.status === 204) {
          let temp_image_url = window.URL.createObjectURL(this.imageOverlay.image);
          const on_server_image_url = this.$refs.profileImage.src;

          this.$refs.profileImage.src = temp_image_url;

          // adapted from https://stackoverflow.com/a/66312176
          // load new image in browser cache
          fetch(on_server_image_url, { cache: 'reload', credentials: 'include' }).then(
            (response) => {
              // In some browsers, the image cache and fetch cache are different,
              // so the following line would reset the old image:
              /* this.$refs.profileImage.src = on_server_image_url;
            window.URL.revokeObjectURL(temp_image_url); */
            }
          );

          this.imageOverlay.image = null;
          this.snackbar.message = 'Profilbild erfolgreich geändert';
          this.snackbar.show = true;
          this.hasProfileImage = true;
        } else if (response.status === 403) {
          this.error = ['Das aktuelle Passwort ist inkorrekt'];
          this.snackbar.show = true;
        } else if (response.status === 400) {
          try {
            this.error = response.json();
            this.snackbar.show = true;
          } catch (error) {
            console.log(error);
            this.$emit('unexpectedError');
          }
        } else if (response.status === 401) {
          this.$router.push('/logout');
        } else {
          this.$emit('unexpectedError');
        }
      } catch (error) {
        console.log(error);
        this.$emit('networkError');
      }
      this.loading = false;
    },
    doChangePassword: function () {
      this.error = [];
      this.snackbar.show = false;

      if (this.$refs.formPassword.validate()) {
        this.loading = true;
        fetch(util.CONFIG.API_BASE_URL + '/v1/account/changepass', {
          method: 'POST',
          credentials: 'include',
          body: JSON.stringify(this.changePassword),
        })
          .then((response) => {
            if (response.status === 204) {
              this.$refs.formPassword.reset();
              this.loading = false;
              this.snackbar.message = 'Passwort erfolgreich geändert';
              this.snackbar.show = true;
            } else if (response.status === 403) {
              this.error = ['Das aktuelle Passwort ist inkorrekt'];
              this.snackbar.show = true;
              this.loading = false;
            } else if (response.status === 400) {
              response
                .json()
                .then((data) => {
                  this.error = data;
                  this.snackbar.show = true;
                  this.loading = false;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else if (response.status === 401) {
              this.$router.push('/logout');
            } else {
              this.$emit('unexpectedError');
              this.loading = false;
            }
          })
          .catch((error) => {
            console.log(error);
            this.$emit('networkError');
          });
      }
    },
    doChangeMailAddress: function () {
      this.error = [];
      this.snackbar.show = false;

      if (this.$refs.formMailAddress.validate()) {
        this.loading = true;
        fetch(
          util.CONFIG.API_BASE_URL +
            '/v1/change_mail/step1/' +
            this.applicationStore.session.user.id,
          {
            method: 'POST',
            credentials: 'include',
            body: JSON.stringify(this.changeMailAddress),
          }
        )
          .then((response) => {
            if (response.status === 201) {
              this.$refs.formMailAddress.reset();
              this.loading = false;
              this.snackbar.message = 'Änderungsprozess erfolgreich angestoßen';
              this.snackbar.show = true;
            } else if (response.status === 401) {
              this.$router.push('/logout');
            } else if (response.status === 400) {
              response
                .json()
                .then((data) => {
                  this.error = data;
                  this.snackbar.show = true;
                  this.loading = false;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else if (response.status === 401) {
              this.$router.push('/logout');
            } else {
              this.$emit('unexpectedError');
              this.loading = false;
            }
          })
          .catch((error) => {
            console.log(error);
            this.$emit('networkError');
          });
      }
    },
  },
  data: () => {
    return {
      loading: false,
      error: [],
      snackbar: {
        show: false,
        message: '',
      },
      changePassword: {
        passwordOld: '',
        password1: '',
        password2: '',
      },
      changeMailAddress: {
        password: '',
        mail: '',
        verified: false,
      },
      passwordRules: [
        (v) => !!v || 'Bitte ein Passwort eingeben',
        (v) => (v || '').length >= 8 || 'Das Passwort muss mindestens 8 Zeichen beinhalten',
        (v) => (v || '').length <= 400 || 'Das Passwort darf maximal 400 Zeichen beinhalten',
      ],
      hasProfileImage: true,
      imageOverlay: {
        show: false,
        image: null,
      },
      applicationStore: useApplicationStore(),
      util,
    };
  },
  beforeUnmount() {
    this.$emit('clearError');
  },
};
</script>

<style scoped></style>
